diff --git a/python/mach/mach/config.py b/python/mach/mach/config.py
index 26c9a4482c..86999aecd3 100644
--- a/python/mach/mach/config.py
+++ b/python/mach/mach/config.py
@@ -24,20 +24,16 @@ gettext .po and .mo file for the en_US locale. The |mach settings locale-gen|
 command can be used to populate these files.
 """
 
-from __future__ import absolute_import, unicode_literals
 
 import collections
+import collections.abc
 import gettext
 import os
 import sys
 from functools import wraps
 
-if sys.version_info[0] == 3:
-    from configparser import RawConfigParser, NoSectionError
-    str_type = str
-else:
-    from ConfigParser import RawConfigParser, NoSectionError
-    str_type = basestring
+from configparser import RawConfigParser, NoSectionError
+str_type = str
 
 
 TRANSLATION_NOT_FOUND = """
@@ -52,7 +48,7 @@ class ConfigException(Exception):
     pass
 
 
-class ConfigType(object):
+class ConfigType:
     """Abstract base class for config values."""
 
     @staticmethod
@@ -149,7 +145,7 @@ TYPE_CLASSES = {
 }
 
 
-class DefaultValue(object):
+class DefaultValue:
     pass
 
 
@@ -163,11 +159,11 @@ def reraise_attribute_error(func):
             return func(*args, **kwargs)
         except KeyError:
             exc_class, exc, tb = sys.exc_info()
-            raise AttributeError().__class__, exc, tb
+            raise AttributeError(str(exc)).with_traceback(tb)
     return _
 
 
-class ConfigSettings(collections.Mapping):
+class ConfigSettings(collections.abc.Mapping):
     """Interface for configuration settings.
 
     This is the main interface to the configuration.
@@ -213,7 +209,7 @@ class ConfigSettings(collections.Mapping):
     will result in exceptions being raised.
     """
 
-    class ConfigSection(collections.MutableMapping, object):
+    class ConfigSection(collections.abc.MutableMapping):
         """Represents an individual config section."""
         def __init__(self, config, name, settings):
             object.__setattr__(self, '_config', config)
@@ -242,7 +238,7 @@ class ConfigSettings(collections.Mapping):
             meta['type_cls'].validate(value)
 
             if 'choices' in meta and value not in meta['choices']:
-                raise ValueError("Value '%s' must be one of: %s" % (
+                raise ValueError("Value '{}' must be one of: {}".format(
                                  value, ', '.join(sorted(meta['choices']))))
 
         # MutableMapping interface
@@ -318,7 +314,7 @@ class ConfigSettings(collections.Mapping):
         """
         filtered = [f for f in filenames if os.path.exists(f)]
 
-        fps = [open(f, 'rt') for f in filtered]
+        fps = [open(f) for f in filtered]
         self.load_fps(fps)
         self.loaded_files.update(set(filtered))
         for fp in fps:
@@ -328,7 +324,7 @@ class ConfigSettings(collections.Mapping):
         """Load config data by reading file objects."""
 
         for fp in fps:
-            self._config.readfp(fp)
+            self._config.read_file(fp)
 
     def write(self, fh):
         """Write the config to a file object."""
@@ -357,7 +353,7 @@ class ConfigSettings(collections.Mapping):
             extra -- A dict of additional key/value pairs to add to the
                 setting metadata.
         """
-        if isinstance(type_cls, basestring):
+        if isinstance(type_cls, str):
             type_cls = TYPE_CLASSES[type_cls]
 
         meta = {
@@ -391,7 +387,7 @@ class ConfigSettings(collections.Mapping):
             section, option = setting[0].split('.')
 
             if option in config_settings[section]:
-                raise ConfigException('Setting has already been registered: %s.%s' % (
+                raise ConfigException('Setting has already been registered: {}.{}'.format(
                                 section, option))
 
             meta = self._format_metadata(provider, section, option, *setting[1:])
@@ -423,8 +419,8 @@ class ConfigSettings(collections.Mapping):
                                 fallback=True)
         t.add_fallback(default)
 
-        short = t.ugettext('%s.%s.short' % (section, option))
-        full = t.ugettext('%s.%s.full' % (section, option))
+        short = t.gettext('{}.{}.short'.format(section, option))
+        full = t.gettext('{}.{}.full'.format(section, option))
 
         return (short, full)
 
diff --git a/python/mach/mach/decorators.py b/python/mach/mach/decorators.py
index 6c1713d7f0..5e3ba0e952 100644
--- a/python/mach/mach/decorators.py
+++ b/python/mach/mach/decorators.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 import argparse
 import collections
@@ -14,7 +13,7 @@ from .base import MachError
 from .registrar import Registrar
 
 
-class _MachCommand(object):
+class _MachCommand:
     """Container for mach command metadata.
 
     Mach commands contain lots of attributes. This class exists to capture them
@@ -110,8 +109,8 @@ def CommandProvider(cls):
     # Tell mach driver whether to pass context argument to __init__.
     pass_context = False
 
-    if inspect.ismethod(cls.__init__):
-        spec = inspect.getargspec(cls.__init__)
+    if inspect.isfunction(cls.__init__) or inspect.ismethod(cls.__init__):
+        spec = inspect.getfullargspec(cls.__init__)
 
         if len(spec.args) > 2:
             msg = 'Mach @CommandProvider class %s implemented incorrectly. ' + \
@@ -151,7 +150,7 @@ def CommandProvider(cls):
               'Conditions argument must take a list ' + \
               'of functions. Found %s instead.'
 
-        if not isinstance(command.conditions, collections.Iterable):
+        if not isinstance(command.conditions, collections.abc.Iterable):
             msg = msg % (command.name, type(command.conditions))
             raise MachError(msg)
 
@@ -206,7 +205,7 @@ def CommandProvider(cls):
     return cls
 
 
-class Command(object):
+class Command:
     """Decorator for functions or methods that provide a mach command.
 
     The decorator accepts arguments that define basic attributes of the
@@ -238,7 +237,7 @@ class Command(object):
 
         return func
 
-class SubCommand(object):
+class SubCommand:
     """Decorator for functions or methods that provide a sub-command.
 
     Mach commands can have sub-commands. e.g. ``mach command foo`` or
@@ -267,7 +266,7 @@ class SubCommand(object):
 
         return func
 
-class CommandArgument(object):
+class CommandArgument:
     """Decorator for additional arguments to mach subcommands.
 
     This decorator should be used to add arguments to mach commands. Arguments
@@ -298,7 +297,7 @@ class CommandArgument(object):
         return func
 
 
-class CommandArgumentGroup(object):
+class CommandArgumentGroup:
     """Decorator for additional argument groups to mach commands.
 
     This decorator should be used to add arguments groups to mach commands.
diff --git a/python/mach/mach/dispatcher.py b/python/mach/mach/dispatcher.py
index 5604d981d7..02b532989b 100644
--- a/python/mach/mach/dispatcher.py
+++ b/python/mach/mach/dispatcher.py
@@ -2,8 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
+from __future__ import print_function
 import argparse
 import difflib
 import shlex
@@ -375,7 +375,7 @@ class CommandAction(argparse.Action):
             ' subcommand [subcommand arguments]'
         group = parser.add_argument_group('Sub Commands')
 
-        for subcommand, subhandler in sorted(handler.subcommand_handlers.iteritems()):
+        for subcommand, subhandler in sorted(handler.subcommand_handlers.items()):
             group.add_argument(subcommand, help=subhandler.description,
                 action='store_true')
 
@@ -437,13 +437,13 @@ def format_docstring(docstring):
     if not docstring:
         return ''
     lines = docstring.expandtabs().splitlines()
-    indent = sys.maxint
+    indent = sys.maxsize
     for line in lines[1:]:
         stripped = line.lstrip()
         if stripped:
             indent = min(indent, len(line) - len(stripped))
     trimmed = [lines[0].strip()]
-    if indent < sys.maxint:
+    if indent < sys.maxsize:
         for line in lines[1:]:
             trimmed.append(line[indent:].rstrip())
     while trimmed and not trimmed[-1]:
diff --git a/python/mach/mach/logging.py b/python/mach/mach/logging.py
index 729e6cb3d9..94253aa2e4 100644
--- a/python/mach/mach/logging.py
+++ b/python/mach/mach/logging.py
@@ -6,7 +6,6 @@
 # support for a structured logging framework built on top of Python's built-in
 # logging framework.
 
-from __future__ import absolute_import, unicode_literals
 
 try:
     import blessings
@@ -75,7 +74,7 @@ class StructuredHumanFormatter(logging.Formatter):
 
         elapsed = self._time(record)
 
-        return '%s %s' % (format_seconds(elapsed), f)
+        return '{} {}'.format(format_seconds(elapsed), f)
 
     def _time(self, record):
         t = record.created - self.start_time
@@ -102,7 +101,7 @@ class StructuredTerminalFormatter(StructuredHumanFormatter):
 
         t = self.terminal.blue(format_seconds(self._time(record)))
 
-        return '%s %s' % (t, self._colorize(f))
+        return '{} {}'.format(t, self._colorize(f))
 
     def _colorize(self, s):
         if not self.terminal:
@@ -129,7 +128,7 @@ class StructuredTerminalFormatter(StructuredHumanFormatter):
         return result
 
 
-class LoggingManager(object):
+class LoggingManager:
     """Holds and controls global logging state.
 
     An application should instantiate one of these and configure it as needed.
diff --git a/python/mach/mach/main.py b/python/mach/mach/main.py
index dec3d7dfd7..e0cf93f961 100644
--- a/python/mach/mach/main.py
+++ b/python/mach/mach/main.py
@@ -5,16 +5,16 @@
 # This module provides functionality for the command-line build tool
 # (mach). It is packaged as a module because everything is a library.
 
-from __future__ import absolute_import, print_function, unicode_literals
-from collections import Iterable
+from collections.abc import Iterable
 
 import argparse
 import codecs
-import imp
+import importlib.util
 import logging
 import os
 import sys
 import traceback
+import types
 import uuid
 
 from .base import (
@@ -139,7 +139,7 @@ class ArgumentParser(argparse.ArgumentParser):
         return text
 
 
-class ContextWrapper(object):
+class ContextWrapper:
     def __init__(self, context, handler):
         object.__setattr__(self, '_context', context)
         object.__setattr__(self, '_handler', handler)
@@ -162,7 +162,7 @@ class ContextWrapper(object):
 
 
 @CommandProvider
-class Mach(object):
+class Mach:
     """Main mach driver type.
 
     This type is responsible for holding global mach state and dispatching
@@ -256,13 +256,16 @@ To see more help for a specific command, run:
         if module_name is None:
             # Ensure parent module is present otherwise we'll (likely) get
             # an error due to unknown parent.
-            if b'mach.commands' not in sys.modules:
-                mod = imp.new_module(b'mach.commands')
-                sys.modules[b'mach.commands'] = mod
+            if 'mach.commands' not in sys.modules:
+                mod = types.ModuleType('mach.commands')
+                sys.modules['mach.commands'] = mod
 
-            module_name = 'mach.commands.%s' % uuid.uuid1().get_hex()
+            module_name = 'mach.commands.%s' % uuid.uuid1().hex
 
-        imp.load_source(module_name, path)
+        spec = importlib.util.spec_from_file_location(module_name, path)
+        mod = importlib.util.module_from_spec(spec)
+        sys.modules[module_name] = mod
+        spec.loader.exec_module(mod)
 
     def load_commands_from_entry_point(self, group='mach.providers'):
         """Scan installed packages for mach command provider entry points. An
@@ -347,7 +350,7 @@ To see more help for a specific command, run:
             # is a TTY. This provides a mechanism to allow said processes to
             # enable emitting code codes, for example.
             if os.isatty(orig_stdout.fileno()):
-                os.environ[b'MACH_STDOUT_ISATTY'] = b'1'
+                os.environ['MACH_STDOUT_ISATTY'] = '1'
 
             return self._run(argv)
         except KeyboardInterrupt:
@@ -528,7 +531,7 @@ To see more help for a specific command, run:
 
             machrc, .machrc
         """
-        if isinstance(paths, basestring):
+        if isinstance(paths, str):
             paths = [paths]
 
         valid_names = ('machrc', '.machrc')
@@ -541,8 +544,7 @@ To see more help for a specific command, run:
                 if os.path.isfile(path):
                     return path
 
-        files = map(find_in_dir, self.settings_paths)
-        files = filter(bool, files)
+        files = list(filter(bool, map(find_in_dir, self.settings_paths)))
 
         self.settings.load_files(files)
 
@@ -560,7 +562,7 @@ To see more help for a specific command, run:
             action='store_true', default=False,
             help='Print verbose output.')
         global_group.add_argument('-l', '--log-file', dest='logfile',
-            metavar='FILENAME', type=argparse.FileType('ab'),
+            metavar='FILENAME', type=argparse.FileType('a'),
             help='Filename to write log data to.')
         global_group.add_argument('--log-interval', dest='log_interval',
             action='store_true', default=False,
diff --git a/python/mach/mach/mixin/logging.py b/python/mach/mach/mixin/logging.py
index 5c37b54f1b..6b31d58753 100644
--- a/python/mach/mach/mixin/logging.py
+++ b/python/mach/mach/mixin/logging.py
@@ -2,12 +2,11 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 import logging
 
 
-class LoggingMixin(object):
+class LoggingMixin:
     """Provides functionality to control logging."""
 
     def populate_logger(self, name=None):
diff --git a/python/mach/mach/mixin/process.py b/python/mach/mach/mixin/process.py
index b8f0eac029..7db0e1d4e2 100644
--- a/python/mach/mach/mixin/process.py
+++ b/python/mach/mach/mixin/process.py
@@ -4,7 +4,6 @@
 
 # This module provides mixins to perform process execution.
 
-from __future__ import absolute_import, unicode_literals
 
 import logging
 import os
@@ -101,24 +100,20 @@ class ProcessExecutionMixin(LoggingMixin):
             if append_env:
                 use_env.update(append_env)
 
-        self.log(logging.DEBUG, 'process', {'env': use_env}, 'Environment: {env}')
-
-        # There is a bug in subprocess where it doesn't like unicode types in
-        # environment variables. Here, ensure all unicode are converted to
-        # binary. utf-8 is our globally assumed default. If the caller doesn't
-        # want UTF-8, they shouldn't pass in a unicode instance.
+        # Ensure all environment keys and values are str (not bytes) for
+        # Python 3 compatibility with subprocess and JSON logging.
         normalized_env = {}
         for k, v in use_env.items():
-            if isinstance(k, unicode):
-                k = k.encode('utf-8', 'strict')
-
-            if isinstance(v, unicode):
-                v = v.encode('utf-8', 'strict')
-
+            if isinstance(k, bytes):
+                k = k.decode('utf-8', 'replace')
+            if isinstance(v, bytes):
+                v = v.decode('utf-8', 'replace')
             normalized_env[k] = v
 
         use_env = normalized_env
 
+        self.log(logging.DEBUG, 'process', {'env': use_env}, 'Environment: {env}')
+
         if pass_thru:
             proc = subprocess.Popen(args, cwd=cwd, env=use_env)
             status = None
diff --git a/python/mach/mach/registrar.py b/python/mach/mach/registrar.py
index 63c9099c08..098cd7e51e 100644
--- a/python/mach/mach/registrar.py
+++ b/python/mach/mach/registrar.py
@@ -2,8 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
+from __future__ import print_function
 from .base import MachError
 
 INVALID_COMMAND_CONTEXT = r'''
@@ -14,7 +14,7 @@ Run |mach help| to show a list of all commands available to the current context.
 '''.lstrip()
 
 
-class MachRegistrar(object):
+class MachRegistrar:
     """Container for mach command and config providers."""
 
     def __init__(self):
@@ -78,7 +78,7 @@ class MachRegistrar(object):
                     fail_conditions.append(c)
 
             if fail_conditions:
-                print(self._condition_failed_message(handler.name, fail_conditions))
+                print((self._condition_failed_message(handler.name, fail_conditions)))
                 return 1
 
         fn = getattr(instance, handler.method)
@@ -90,7 +90,7 @@ class MachRegistrar(object):
             result = fn(**kwargs)
 
         result = result or 0
-        assert isinstance(result, (int, long))
+        assert isinstance(result, int)
 
         if context:
             postrun = getattr(context, 'post_dispatch_handler', None)
diff --git a/python/mach/mach/terminal.py b/python/mach/mach/terminal.py
index 9115211e02..0f787ff9a6 100644
--- a/python/mach/mach/terminal.py
+++ b/python/mach/mach/terminal.py
@@ -8,7 +8,6 @@ All the terminal interaction code is consolidated so the complexity can be in
 one place, away from code that is commonly looked at.
 """
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 import logging
 import sys
@@ -52,14 +51,14 @@ class LoggingHandler(logging.Handler):
         self.flush()
 
 
-class TerminalFooter(object):
+class TerminalFooter:
     """Represents something drawn on the bottom of a terminal."""
     def __init__(self, terminal):
         self.t = terminal
         self.fh = sys.stdout
 
     def _clear_lines(self, n):
-        for i in xrange(n):
+        for i in range(n):
             self.fh.write(self.t.move_x(0))
             self.fh.write(self.t.clear_eol())
             self.fh.write(self.t.move_up())
diff --git a/python/mach/mach/test/common.py b/python/mach/mach/test/common.py
index f68ff50950..4ff985c678 100644
--- a/python/mach/mach/test/common.py
+++ b/python/mach/mach/test/common.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import unicode_literals
 
 from StringIO import StringIO
 import os
diff --git a/python/mach/mach/test/providers/basic.py b/python/mach/mach/test/providers/basic.py
index f2e64e6d65..ea36efc525 100644
--- a/python/mach/mach/test/providers/basic.py
+++ b/python/mach/mach/test/providers/basic.py
@@ -1,7 +1,6 @@
 # This Source Code Form is subject to the terms of the Mozilla Public
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
-from __future__ import unicode_literals
 
 from mach.decorators import (
     CommandArgument,
@@ -11,7 +10,7 @@ from mach.decorators import (
 
 
 @CommandProvider
-class ConditionsProvider(object):
+class ConditionsProvider:
     @Command('cmd_foo', category='testing')
     def run_foo(self):
         pass
diff --git a/python/mach/mach/test/providers/conditions.py b/python/mach/mach/test/providers/conditions.py
index a95429752d..35b2c8cd4a 100644
--- a/python/mach/mach/test/providers/conditions.py
+++ b/python/mach/mach/test/providers/conditions.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import unicode_literals
 
 from mach.decorators import (
     CommandProvider,
@@ -18,7 +17,7 @@ def is_bar(cls):
     return cls.bar
 
 @CommandProvider
-class ConditionsProvider(object):
+class ConditionsProvider:
     foo = True
     bar = False
 
@@ -35,7 +34,7 @@ class ConditionsProvider(object):
         pass
 
 @CommandProvider
-class ConditionsContextProvider(object):
+class ConditionsContextProvider:
     def __init__(self, context):
         self.foo = context.foo
         self.bar = context.bar
diff --git a/python/mach/mach/test/providers/conditions_invalid.py b/python/mach/mach/test/providers/conditions_invalid.py
index 22284d4dca..597c7d24a7 100644
--- a/python/mach/mach/test/providers/conditions_invalid.py
+++ b/python/mach/mach/test/providers/conditions_invalid.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import unicode_literals
 
 from mach.decorators import (
     CommandProvider,
@@ -10,7 +9,7 @@ from mach.decorators import (
 )
 
 @CommandProvider
-class ConditionsProvider(object):
+class ConditionsProvider:
     @Command('cmd_foo', category='testing', conditions=["invalid"])
     def run_foo(self):
         pass
diff --git a/python/mach/mach/test/providers/throw.py b/python/mach/mach/test/providers/throw.py
index 06bee01eec..f7ae42ca17 100644
--- a/python/mach/mach/test/providers/throw.py
+++ b/python/mach/mach/test/providers/throw.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import unicode_literals
 
 import time
 
@@ -16,7 +15,7 @@ from mach.test.providers import throw2
 
 
 @CommandProvider
-class TestCommandProvider(object):
+class TestCommandProvider:
     @Command('throw', category='testing')
     @CommandArgument('--message', '-m', default='General Error')
     def throw(self, message):
diff --git a/python/mach/mach/test/test_conditions.py b/python/mach/mach/test/test_conditions.py
index 20080687e3..d637ca8404 100644
--- a/python/mach/mach/test/test_conditions.py
+++ b/python/mach/mach/test/test_conditions.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import unicode_literals
 
 import os
 
@@ -34,8 +33,8 @@ class TestConditions(TestBase):
     def test_conditions_pass(self):
         """Test that a command which passes its conditions is runnable."""
 
-        self.assertEquals((0, '', ''), self._run_mach(['cmd_foo']))
-        self.assertEquals((0, '', ''), self._run_mach(['cmd_foo_ctx'], _populate_context))
+        self.assertEqual((0, '', ''), self._run_mach(['cmd_foo']))
+        self.assertEqual((0, '', ''), self._run_mach(['cmd_foo_ctx'], _populate_context))
 
     def test_invalid_context_message(self):
         """Test that commands which do not pass all their conditions
@@ -47,17 +46,17 @@ class TestConditions(TestBase):
 
         for name in ('cmd_bar', 'cmd_foobar'):
             result, stdout, stderr = self._run_mach([name])
-            self.assertEquals(1, result)
+            self.assertEqual(1, result)
 
             fail_msg = Registrar._condition_failed_message(name, fail_conditions)
-            self.assertEquals(fail_msg.rstrip(), stdout.rstrip())
+            self.assertEqual(fail_msg.rstrip(), stdout.rstrip())
 
         for name in ('cmd_bar_ctx', 'cmd_foobar_ctx'):
             result, stdout, stderr = self._run_mach([name], _populate_context)
-            self.assertEquals(1, result)
+            self.assertEqual(1, result)
 
             fail_msg = Registrar._condition_failed_message(name, fail_conditions)
-            self.assertEquals(fail_msg.rstrip(), stdout.rstrip())
+            self.assertEqual(fail_msg.rstrip(), stdout.rstrip())
 
     def test_invalid_type(self):
         """Test that a condition which is not callable raises an exception."""
diff --git a/python/mach/mach/test/test_config.py b/python/mach/mach/test/test_config.py
index d48dff67b2..a546c27eb2 100644
--- a/python/mach/mach/test/test_config.py
+++ b/python/mach/mach/test/test_config.py
@@ -1,7 +1,6 @@
 # This Source Code Form is subject to the terms of the Mozilla Public
 # License, v. 2.0. If a copy of the MPL was not distributed with this file,
 # You can obtain one at http://mozilla.org/MPL/2.0/.
-from __future__ import unicode_literals
 
 import sys
 import unittest
@@ -22,10 +21,7 @@ from mach.decorators import SettingsProvider
 from mozunit import main
 
 
-if sys.version_info[0] == 3:
-    str_type = str
-else:
-    str_type = basestring
+str_type = str
 
 CONFIG1 = r"""
 [foo]
@@ -41,7 +37,7 @@ bar = value2
 """
 
 @SettingsProvider
-class Provider1(object):
+class Provider1:
     config_settings = [
         ('foo.bar', StringType),
         ('foo.baz', PathType),
@@ -49,7 +45,7 @@ class Provider1(object):
 
 
 @SettingsProvider
-class ProviderDuplicate(object):
+class ProviderDuplicate:
     config_settings = [
         ('dupesect.foo', StringType),
         ('dupesect.foo', StringType),
@@ -57,7 +53,7 @@ class ProviderDuplicate(object):
 
 
 @SettingsProvider
-class Provider2(object):
+class Provider2:
     config_settings = [
         ('a.string', StringType),
         ('a.boolean', BooleanType),
@@ -68,7 +64,7 @@ class Provider2(object):
 
 
 @SettingsProvider
-class Provider3(object):
+class Provider3:
     @classmethod
     def config_settings(cls):
         return [
@@ -81,7 +77,7 @@ class Provider3(object):
 
 
 @SettingsProvider
-class Provider4(object):
+class Provider4:
     config_settings = [
         ('foo.abc', StringType, 'a', {'choices': set('abc')}),
         ('foo.xyz', StringType, 'w', {'choices': set('xyz')}),
@@ -89,7 +85,7 @@ class Provider4(object):
 
 
 @SettingsProvider
-class Provider5(object):
+class Provider5:
     config_settings = [
         ('foo.*', 'string'),
         ('foo.bar', 'string'),
diff --git a/python/mach/mach/test/test_dispatcher.py b/python/mach/mach/test/test_dispatcher.py
index 3d689a4a20..01b2412336 100644
--- a/python/mach/mach/test/test_dispatcher.py
+++ b/python/mach/mach/test/test_dispatcher.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import unicode_literals
 
 import os
 from cStringIO import StringIO
@@ -26,7 +25,7 @@ class TestDispatcher(TestBase):
             mach.settings.register_provider(provider)
 
         if config:
-            if isinstance(config, basestring):
+            if isinstance(config, str):
                 config = StringIO(config)
             mach.settings.load_fps([config])
 
@@ -44,11 +43,11 @@ cmd_bar = cmd_bar --baz
         parser = self.get_parser(config=config)
 
         args = parser.parse_args(['foo'])
-        self.assertEquals(args.command, 'cmd_foo')
+        self.assertEqual(args.command, 'cmd_foo')
 
         def assert_bar_baz(argv):
             args = parser.parse_args(argv)
-            self.assertEquals(args.command, 'cmd_bar')
+            self.assertEqual(args.command, 'cmd_bar')
             self.assertTrue(args.command_args.baz)
 
         # The following should all result in |cmd_bar --baz|
diff --git a/python/mach/mach/test/test_entry_point.py b/python/mach/mach/test/test_entry_point.py
index 7aea91e5e4..34eac232bf 100644
--- a/python/mach/mach/test/test_entry_point.py
+++ b/python/mach/mach/test/test_entry_point.py
@@ -1,7 +1,6 @@
 # This Source Code Form is subject to the terms of the Mozilla Public
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
-from __future__ import unicode_literals
 
 import imp
 import os
@@ -9,7 +8,7 @@ import sys
 
 from mach.base import MachError
 from mach.test.common import TestBase
-from mock import patch
+from unittest.mock import patch
 
 from mozunit import main
 
diff --git a/python/mach/mach/test/test_error_output.py b/python/mach/mach/test/test_error_output.py
index 25553f96bc..58e3d032ea 100644
--- a/python/mach/mach/test/test_error_output.py
+++ b/python/mach/mach/test/test_error_output.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import unicode_literals
 
 from mach.main import (
     COMMAND_ERROR,
diff --git a/python/mach/mach/test/test_logger.py b/python/mach/mach/test/test_logger.py
index 05592845e7..6eb6036f14 100644
--- a/python/mach/mach/test/test_logger.py
+++ b/python/mach/mach/test/test_logger.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 import logging
 import time
diff --git a/python/mach_commands.py b/python/mach_commands.py
index 5ff0b1876e..98a78056b0 100644
--- a/python/mach_commands.py
+++ b/python/mach_commands.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 import __main__
 import argparse
@@ -36,7 +35,7 @@ class MachCommands(MachCommandBase):
             pass_thru=True,  # Allow user to run Python interactively.
             ensure_exit_code=False,  # Don't throw on non-zero exit code.
             # Note: subprocess requires native strings in os.environ on Windows
-            append_env={b'PYTHONDONTWRITEBYTECODE': str('1')})
+            append_env={b'PYTHONDONTWRITEBYTECODE': '1'})
 
     @Command('python-test', category='testing',
         description='Run Python unit tests with an appropriate test runner.')
@@ -130,7 +129,7 @@ class MachCommands(MachCommandBase):
                 ensure_exit_code=False,  # Don't throw on non-zero exit code.
                 log_name='python-test',
                 # subprocess requires native strings in os.environ on Windows
-                append_env={b'PYTHONDONTWRITEBYTECODE': str('1')},
+                append_env={b'PYTHONDONTWRITEBYTECODE': '1'},
                 line_handler=_line_handler)
             return_code += inner_return_code
 
